const numOfDigits = 4;
var rawModelsNums = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtr:number/nums_bvg_f.obj"), null);
var modelNum = uploadNumModels(rawModelsNums);

function numRender(ctx, train, state, matrices, offset, carInd, id) {
	id = id % 10000;
	let idStr = id.toString().padStart(numOfDigits, '0');

	let firstOffset = offset * 0.5 * (- idStr.length + 1);

	matrices.pushPose();
	for (var i = 0; i < idStr.length; i++) {
		matrices.translate(firstOffset + i * offset, 0, 0);
		
		ctx.drawCarModel(modelNum["" + idStr[i]], carInd, matrices);
		matrices.translate(-(firstOffset + i * offset), 0, 0);
	}
	matrices.popPose();

	
}


function uploadNumModels(rawModels) { 
  result = {};
  for (it = rawModels.entrySet().iterator(); it.hasNext(); ) {
    entry = it.next();

    let jsStringKey = "" + entry.getKey(); 
    entry.getValue().applyUVMirror(false, true);
    result["" + jsStringKey] = ModelManager.uploadVertArrays(entry.getValue());
  }
  return result;
}